package provide app-kaleidoScope 1.0

package require nx
package require TM

namespace eval app-kaleidoScope {

  set examples {
    stack-example.tcl
    account-example.tcl
  }
  
  if {$argc == 0} {
    set answer ""
    while {1} {
      if {$answer eq ""} {
	puts "Choose a KaleidoScope demo to run:"
	puts "   (1) Stack (example from paper)"
	puts "   (2) Account"
	puts -nonewline "Run demo #: "
	flush stdout
      }
      append answer [gets stdin]
      if {$answer ne ""} {
	if {[scan $answer "%d" option]} {
	  set file [lindex $examples [expr {$option - 1}]]
	  set path [file join $starkit::topdir lib app-kaleidoScope $file]
	  namespace eval :: [list source $path]
	  break
	} else {
	  puts "<!> Provide be a numeric choice between '1' and '[llength $examples]'."
	  set answer ""
	}
      }
      continue
    }
  } else {
    set argv0 [lindex $argv 0]
    set argv  [lreplace $argv 0 0]
    incr argc -1
    source $argv0
  }
}
